<TeXmacs|1.0.7.20>

<style|<tuple|beamer|tmdoc-traversal|maxima|pari|mathemagix>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<with|font-base-size|17|Effective real numbers>>

      by Joris van der Hoeven
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<image|texmacs-chip.ps|0.5w|0.5h||>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Presentation
      with <strong|<with|color|dark green|GNU> <anim-repeat|<TeXmacs*>>>
      (<verbatim|www.texmacs.org)>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Effective real numbers in <name|Mmxlib>>

    <\session|mathemagix|default>
      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        x:Real\<longequal\>sin sin real 2;
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        x
      <|folded-io-math>
        <math|7.891*10<rsup|\<um\>1>> <right-flush>
        <math|<with|color|brown|mode|text|Real>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        approximate(x,1.0e\<um\>35);
      <|folded-io-math>
        <math|7.8907234357288836143140304248688412*10<rsup|\<um\>1>>
        <right-flush> <math|<with|color|brown|mode|text|Interval>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        M:Matrix Real\<longequal\><matrix|<tformat|<table|<row|<cell|x>|<cell|x+2>>|<row|<cell|2-x<rsup|2>>|<cell|cos
        x>>>>>;
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        M;
      <|folded-io-math>
        <math|<left|[><tabular*|<tformat|<table|<row|<cell|7.891*10<rsup|\<um\>1>>|<cell|2.789>>|<row|<cell|1.377>|<cell|7.045*10<rsup|\<um\>1>>>>>><right|]>>
        <right-flush> <math|<with|color|brown|<text|Matrix><left|(><text|Real><right|)>>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        M<rsup|20>;
      <|folded-io-math>
        <math|<left|[><tabular*|<tformat|<table|<row|<cell|2.284*10<rsup|8>>|<cell|3.181*10<rsup|8>>>|<row|<cell|1.571*10<rsup|8>>|<cell|2.188*10<rsup|8>>>>>><right|]>>
        <right-flush> <math|<with|color|brown|<text|Matrix><left|(><text|Real><right|)>>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        exp (x+exp(\<um\>real 100))-exp (x);
      <|folded-io-math>
        <math|8.189*10<rsup|\<um\>44>> <right-flush>
        <math|<with|color|brown|mode|text|Real>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        exp (x+exp(\<um\>real 1000))-exp (x);
      <|folded-io-math>
        <math|0> <right-flush> <math|<with|color|brown|mode|text|Real>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        \;
      </input-math>
    </session>
  </hidden>|<\hidden>
    <tit|Effective analytic functions in <name|Mmxlib>>

    <\session|mathemagix|default>
      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        z:Analytic\<longequal\>analytic (0,1);
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        exp(z);
      <|folded-io-math>
        <math|1.000+1.000*z+5.000*10<rsup|\<um\>1>*z<rsup|2>+1.667*10<rsup|\<um\>1>*z<rsup|3>+4.167*10<rsup|\<um\>2>*z<rsup|4>+8.333*10<rsup|\<um\>3>*z<rsup|5>+1.389*10<rsup|\<um\>3>*z<rsup|6>+1.984*10<rsup|\<um\>4>*z<rsup|7>+2.480*10<rsup|\<um\>5>*z<rsup|8>+2.756*10<rsup|\<um\>6>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
        <right-flush> <math|<with|color|brown|mode|text|Analytic>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        exp(z)[int 20];
      <|folded-io-math>
        <math|4.110*10<rsup|\<um\>19>> <right-flush>
        <math|<with|color|brown|mode|text|Complex>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        \<ell\>:Analytic\<longequal\>log(1-z);
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        radius(\<ell\>);
      <|folded-io-math>
        <math|9.99937726184725761359*10<rsup|\<um\>1>> <right-flush>
        <math|<with|color|brown|mode|text|Floating>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        evaluate(\<ell\>,complex(1/2));
      <|folded-io-math>
        <math|\<um\>6.931*10<rsup|\<um\>1>> <right-flush>
        <math|<with|color|brown|mode|text|Complex>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        continuate(\<ell\>,complex(1/2));
      <|folded-io-math>
        <math|\<um\>6.931*10<rsup|\<um\>1>-2.000*z-2.000*z<rsup|2>-2.667*z<rsup|3>-4.000*z<rsup|4>-6.400*z<rsup|5>-1.067*10<rsup|1>*z<rsup|6>-1.829*10<rsup|1>*z<rsup|7>-3.200*10<rsup|1>*z<rsup|8>-5.689*10<rsup|1>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
        <right-flush> <math|<with|color|brown|mode|text|Analytic>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        continuate(\<ell\>,turn(complex(1)));
      <|folded-io-math>
        <math|6.283*\<mathi\>-1.000*z-5.000*10<rsup|\<um\>1>*z<rsup|2>-3.333*10<rsup|\<um\>1>*z<rsup|3>-2.500*10<rsup|\<um\>1>*z<rsup|4>-2.000*10<rsup|\<um\>1>*z<rsup|5>-1.667*10<rsup|\<um\>1>*z<rsup|6>-1.429*10<rsup|\<um\>1>*z<rsup|7>-1.250*10<rsup|\<um\>1>*z<rsup|8>-1.111*10<rsup|\<um\>1>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
        <right-flush> <math|<with|color|brown|mode|text|Analytic>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        \;
      </input-math>
    </session>
  </hidden>|<\hidden>
    <tit|Solving differential equations>

    <\equation*>
      f<rprime|''>=(z<rsup|2>+1)*f<rprime|'>+\<mathe\><rsup|z>*f;<space|2em>f(0)=1,f<rprime|'>(0)=1+2*\<mathi\>.
    </equation*>

    <\session|mathemagix|default>
      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        f:Analytic\<longequal\>solve_lde((z<rsup|2>+1,exp(z)),(complex(1),complex(1,2)));
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        f;
      <|folded-io-math>
        <math|1.000+<left|(>1.000+2.000*\<mathi\><right|)>*z+<left|(>1.000+1.000*\<mathi\><right|)>*z<rsup|2>+<left|(>6.667*10<rsup|\<um\>1>+1.000*\<mathi\><right|)>*z<rsup|3>+<left|(>5.417*10<rsup|\<um\>1>+5.833*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|4>+<left|(>3.500*10<rsup|\<um\>1>+4.833*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|5>+<left|(>2.278*10<rsup|\<um\>1>+2.750*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|6>+<left|(>1.343*10<rsup|\<um\>1>+1.742*10<rsup|\<um\>1>*\<mathi\><right|)>*z<rsup|7>+<left|(>7.882*10<rsup|\<um\>2>+9.767*10<rsup|\<um\>2>*\<mathi\><right|)>*z<rsup|8>+<left|(>4.361*10<rsup|\<um\>2>+5.572*10<rsup|\<um\>2>*\<mathi\><right|)>*z<rsup|9>+O<left|(>z<rsup|10><right|)>>
        <right-flush> <math|<with|color|brown|mode|text|Analytic>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        u:Complex\<longequal\>evaluate(f,complex(1/10));
      </input-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        u;
      <|folded-io-math>
        <math|1.111+2.111*10<rsup|\<um\>1>*\<mathi\>> <right-flush>
        <math|<with|color|brown|mode|text|Complex>>
      </folded-io-math>

      <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
        approximate(u,1.0e\<um\>81);
      <|folded-io-math>
        <math|1.11072457537794457102292725574830566357052541308848196626687047567517902828392834+2.1106346012282867466007605052618438398248510727864880851400427655460836641117663*10<rsup|\<um\>1>*\<mathi\>>
        <right-flush> <math|<with|color|brown|<text|Complexify><left|(><text|Interval><right|)>>>
      </folded-io-math>

      <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
        \;
      </input-math>
    </session>
  </hidden>|<\hidden>
    <tit|Definition of effective real numbers>

    <\itemize>
      <unroll|<\shown>
        <item><math|<wide|x|~>\<in\>\<bbb-D\>=\<bbb-Z\>*2<rsup|\<bbb-Z\>>> is
        an <math|\<varepsilon\>>-approximation of <math|x\<in\>\<bbb-R\>> if
        <math|\|<wide|x|~>-x\|\<less\>\<varepsilon\>>.
      </shown>|<\hidden*>
        <item><em|Approximation algorithm> for <math|x>: computes
        <math|\<varepsilon\>> <math|\<longmapsto\>>
        <math|\<varepsilon\>>-approximation of <math|x>.
      </hidden*>|<\hidden*>
        <item><em|Effective real number>: <math|x\<in\>\<bbb-R\>> which
        admits an approximation algorithm.
      </hidden*>|<\hidden*>
        <item><em|Complexity> of <math|x>: time needed to compute a
        <math|2<rsup|\<um\>l>>-approximation.
      </hidden*>|<\hidden*>
        <item>Implementation of <verbatim|real> as pointer to

        <\code>
          class real_rep {

          public:

          \ \ virtual dyadic approximate (const dyadic& err) = 0;

          \ \ ...

          };
        </code>
      </hidden*>|<\hidden*>
        <item>No zero-test for effective real numbers.
      </hidden*>|<\hidden*>
        <item>References: Bishop and Bridges, Blanck, Mller, vdH,
        <abbr|etc.>
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|Modeling computations with effective real numbers>

    <\itemize>
      <unroll|<\shown>
        <item>Example: addition

        <\code>
          class add_real_rep: public real_rep {

          \ \ real x, y;

          \ \ add_real_rep (const real& x2, const real& y2):

          \ \ \ \ x (x2), y (y2) {}

          \ \ dyadic approximate (const dyadic& eps) {

          \ \ \ \ return x-\<gtr\>approximate (eps/2) + y-\<gtr\>approximate
          (eps/2); }

          };
        </code>
      </shown>|<\hidden*>
        <item>Model sets of effective real numbers by acyclic graphs:

        <\with|par-mode|center>
          <with|gr-mode|<tuple|edit|spline>|gr-frame|<tuple|scale|1cm|<tuple|0.7gw|0.500002gh>>|gr-geometry|<tuple|geometry|0.303834par|0.299315par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|<graphics|<with|text-at-halign|center|<text-at|<math|+>|<point|0|1.5>>>|<with|text-at-halign|center|<text-at|<math|\<times\>>|<point|-1|0.5>>>|<line|<point|-0.176793|1.41672>|<point|-0.80333|0.790184>>|<with|text-at-halign|center|<text-at|<math|\<um\>>|<point|0.7|0.5>>>|<with|text-at-halign|center|<text-at|1|<point|-1.8|-1.5>>>|<with|text-at-halign|center|<text-at|3|<point|-0.3|-1.5>>>|<line|<point|0.144943|1.39979>|<point|0.686814|0.790184>>|<line|<point|-0.80333|0.383781>|<point|-0.3|-0.1>>|<line|<point|-1.20973|0.383781>|<point|-1.7008|-0.0903559>>|<with|text-at-halign|center|<text-at|sin|<point|-1.8|-0.4>>>|<with|text-at-halign|center|<text-at|cos|<point|-0.3|-0.4>>>|<line|<point|-1.8024|-0.564493>|<point|-1.8|-1.1>>|<spline|<point|0.602146|0.383781>|<point|0.4|0>|<point|0.0433424|-0.276624>>|<spline|<point|0.906949|0.400714>|<point|0.6|-0.6>|<point|-0.109059|-1.19103>>|<line|<point|-0.301065|-0.564493>|<point|-0.301065|-1.1233>>|<with|text-at-halign|center|<text-at|<math|cos>|<point|-2.2|1.5>>>|<spline|<point|-2.23148|1.39479>|<point|-2.2|0.6>|<point|-2.01134|-0.112283>>>>
        </with>
      </hidden*>|<\hidden*>
        <item>Computations stored in memory <math|\<rightarrow\>> don't use
        classical numerical algorithms.
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|<em|A priori> error estimates>

    <\itemize>
      <unroll|<\shown>
        <item>Distribute tolerance <math|\<varepsilon\>> <em|a priori> over
        nodes of <math|n>-ary operations (<math|n\<gtr\>1>).
      </shown>|<\hidden*>
        <switch|<\shown>
          <item>Can be bad in case of badly nested expressions:

          <\equation*>
            <tree|+|x<rsub|1>|<tree|+|\<ddots\>|<tree|+|x<rsub|r-1>|x<rsub|r>>>><space|6em><tree|\<varepsilon\>|<with|math-display|false|<frac|1|2>>*\<varepsilon\>|<tree|<with|math-display|false|<frac|1|2>>*\<varepsilon\>|\<ddots\>|<tree|\<vdots\>|<with|math-display|false|<frac|1|2<rsup|r-1>>>*\<varepsilon\>|<with|math-display|false|<frac|1|2<rsup|r-1>>>*\<varepsilon\>>>>
          </equation*>
        </shown>|<\hidden>
          <item>Balanced error estimates: redistribute as a function of
          <em|weight>:

          <\equation*>
            <tree|+|x<rsub|1>|<tree|+|\<ddots\>|<tree|+|x<rsub|r-1>|x<rsub|r>>>><space|6em><tree|\<varepsilon\>|<with|math-display|false|<frac|1|r>>*\<varepsilon\>|<tree|<with|math-display|false|<frac|r-1|r>>*\<varepsilon\>|\<ddots\>|<tree|\<vdots\>|<with|math-display|false|<frac|1|r>>*\<varepsilon\>|<with|math-display|false|<frac|1|r>>*\<varepsilon\>>>>
          </equation*>
        </hidden>>
      </hidden*>|<\hidden*>
        <item>Possible loss of <math|log w> bits of precision; still
        unacceptable.
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|<em|A posteriori> error estimates>

    <\itemize>
      <unroll|<\shown>
        <item>Perform whole computation using interval arithmetic.

        While result not precise enough:

        \ \ \ \ Double precision and redo entire computation.
      </shown>|<\hidden*>
        <item>First improvement:

        For each instance of <verbatim|real_rep>, keep best current
        approximation in memory.
      </hidden*>|<\hidden*>
        <item>Second improvement:

        Don't double precision, but estimated computation time.
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|Representation of intervals>

    <\itemize>
      <unroll|<\shown>
        <item><math|W=16,32,64,128,\<ldots\>> bit precision of the processor.

        <item><math|\<bbb-D\><rsub|l>> set of generalized IEEE 754 numbers of
        precision <math|l> and fixed exponent range.
      </shown>|<\hidden*>
        <switch|<\shown>
          <item><with|color|red|Standard representation at precision
          <math|l>>

          <math|\<b-x\>=[<wide*|\<b-x\>|\<wide-bar\>>,<wide|\<b-x\>|\<wide-bar\>>]>,
          with <math|<wide*|\<b-x\>|\<wide-bar\>>\<leqslant\><wide|\<b-x\>|\<wide-bar\>>\<in\>\<bbb-D\><rsub|l><mid|\\>{NaN}>
          or <math|\<b-x\>=NaIn>.

          <\itemize-minus>
            <item>Easy to implement on top of <name|Mpfr>.

            <item>Inherits standardization from IEEE 754.

            <item>Requires two <math|l>-bit computations for each operation.
          </itemize-minus>
        </shown>|<\hidden>
          <item><with|color|red|Ball representation at precision <math|l>>

          <math|\<b-x\>=\<cal-B\>(c<rsub|\<b-x\>>,r<rsub|\<b-x\>>)> with
          <math|<with|math-display|true|<choice|<tformat|<table|<row|<cell|c<rsub|x>\<in\>\<bbb-D\><rsub|l>\<nin\>{NaN,\<upm\>0,\<upm\>\<infty\>}>>|<row|<cell|r<rsub|x>\<in\>\<bbb-D\><rsub|l><rsup|\<geqslant\>>,
          l\<gtr\>W\<Rightarrow\>r<rsub|\<b-x\>>\<leqslant\>\|c<rsub|\<b-x\>>\|*2<rsup|W-l>>>>>>>>
          or <math|\<b-x\>=NaIn>

          <\itemize-minus>
            <item>Efficient and easy to implement for high precisions.

            <item>Less expressive power: cannot represent
            <math|[0,\<infty\>]>.

            <item>Difficult to preserve positivity:
            <math|\<cal-B\>(a,a)+B(b,b)>.
          </itemize-minus>
        </hidden>|<\hidden>
          <item><with|color|red|Hybrid representation at precision <math|l>>

          Use standard representation for <math|l=W>.

          Use ball representation for <math|l\<gtr\>W>.
        </hidden>>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Semantics and standardization>

    <\itemize>
      <unroll|<\shown>
        <item><with|color|red|Precision loss and normalization>

        Example: <math|2.0060000000123-2.0060000000000\<longrightarrow\>1.23\<times\>10<rsup|\<um\>10>>.

        <math|<op|\<longrightarrow\>>> Set of intervals at precision <math|l>
        not stable under <math|<op|+>>, <math|<op|->>, <math|<op|\<times\>>>,
        <abbr|etc.>

        <math|<op|\<longrightarrow\>>> Set <math|\<bbb-I\><rsub|l>> of
        intervals at precision <math|<op|\<leqslant\>> l> is stable under
        <math|<op|+>>, <math|<op|->>, <math|<op|\<times\>>>, <abbr|etc.>
      </shown>|<\hidden*>
        <item><with|color|red|Precision gains>

        Example 1: <math|log<rsub|10> 1.0\<times\>10<rsup|1000>\<longrightarrow\>1.0000\<times\>10<rsup|3>>.

        Example 2: <math|arc tan 1.0\<times\>10<rsup|10>\<longrightarrow\>1.5707963267>.

        <math|<op|\<longrightarrow\>>> We compute with precision
        <math|min(l,precision arguments)>.
      </hidden*>|<\hidden*>
        <item><with|color|red|Semantics>

        <math|<op|\<longrightarrow\>>> Perform operation as if we use
        <math|l> bit precision in standard representation.

        <math|<op|\<longrightarrow\>>> Normalize result to hybrid
        representation.

        <math|<op|\<longrightarrow\>>> Return <math|NaIn> as soon as error
        occurs for one possible value.

        <math|<op|\<longrightarrow\>>> Loosen: allow for
        <math|2<rsup|\<um\>W>> relative errors.
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Template types over <verbatim|interval>>

    <\itemize>
      <unroll|<\shown>
        <item>Complex numbers

        <\session|mathemagix|default>
          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            forall(T) power(x:T,n:Integer) :T\<longequal\>

            <space|1em>(if n=1 then x else x*power(x,n-1));
          </input-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            \<alpha\>:Interval\<longequal\>approximate(real
            2,1.0e\<um\>24);\<alpha\>;
          <|folded-io-math>
            <math|2.00000000000000000000000> <right-flush>
            <math|<with|color|brown|mode|text|Interval>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            \<beta\>:Complexify Interval\<longequal\>approximate(complex(1,1),1.0e\<um\>24);\<beta\>;
          <|folded-io-math>
            <math|1.00000000000000000000000+1.00000000000000000000000*\<mathi\>>
            <right-flush> <math|<with|color|brown|<text|Complexify><left|(><text|Interval><right|)>>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            for i:Integer in 1\<ldots\>10 loop
            mmout\<ll\>power(\<beta\>,8*i)\<ll\>"\\n";
          <|folded-io-math>
            <math|1.6000000000000000000000*10<rsup|1>+0.0*10<rsup|\<um\>23>*\<mathi\>>

            <math|2.56000000000000000000*10<rsup|2>+0.0*10<rsup|\<um\>21>*\<mathi\>>

            <math|4.0960000000000000000*10<rsup|3>+0.0*10<rsup|\<um\>19>*\<mathi\>>

            <math|6.553600000000000000*10<rsup|4>+0.0*10<rsup|\<um\>16>*\<mathi\>>

            <math|1.04857600000000000*10<rsup|6>+0.0*10<rsup|\<um\>14>*\<mathi\>>

            <math|1.6777216000000000*10<rsup|7>+0.0*10<rsup|\<um\>11>*\<mathi\>>

            <math|2.68435456000000*10<rsup|8>+0.0*10<rsup|\<um\>9>*\<mathi\>>

            <math|4.2949672960000*10<rsup|9>+0.0*10<rsup|\<um\>7>*\<mathi\>>

            <math|6.871947673600*10<rsup|10>+0.0*10<rsup|\<um\>4>*\<mathi\>>

            <math|1.09951162778*10<rsup|12>+0.0*10<rsup|\<um\>2>*\<mathi\>>
          </folded-io-math>

          <\folded-io-math|<with|color|red|Mmx <math|\<gg\>>> >
            for i:Integer in 1\<ldots\>10 loop
            mmout\<ll\>\<beta\><rsup|8*i>\<ll\>"\\n";
          <|folded-io-math>
            <math|1.6000000000000000000000*10<rsup|1>+0.0*10<rsup|\<um\>24>*\<mathi\>>

            <math|2.5600000000000000000000*10<rsup|2>+0.0*10<rsup|\<um\>23>*\<mathi\>>

            <math|4.0960000000000000000000*10<rsup|3>+0.0*10<rsup|\<um\>21>*\<mathi\>>

            <math|6.5536000000000000000000*10<rsup|4>+0.0*10<rsup|\<um\>20>*\<mathi\>>

            <math|1.048576000000000000000*10<rsup|6>+0.0*10<rsup|\<um\>18>*\<mathi\>>

            <math|1.677721600000000000000*10<rsup|7>+0.0*10<rsup|\<um\>17>*\<mathi\>>

            <math|2.684354560000000000000*10<rsup|8>+0.0*10<rsup|\<um\>16>*\<mathi\>>

            <math|4.294967296000000000000*10<rsup|9>+0.0*10<rsup|\<um\>15>*\<mathi\>>

            <math|6.871947673600000000000*10<rsup|10>+0.0*10<rsup|\<um\>13>*\<mathi\>>

            <math|1.099511627776000000000*10<rsup|12>+0.0*10<rsup|\<um\>12>*\<mathi\>>
          </folded-io-math>

          <\input-math|<with|color|red|Mmx <math|\<gg\>>> >
            \;
          </input-math>
        </session>

        Systematically use ball representation.
      </shown>|<\hidden*>
        <item>Matrices

        Compute matrix products <math|M<rsub|1>*\<cdots\>*M<rsub|n>> by
        dichotomy.

        For instance: <math|M<rsub|1>*\<cdots\>*M<rsub|8>=(((M<rsub|1>*M<rsub|2>)*(M<rsub|3>*M<rsub|4>))*((M<rsub|5>*M<rsub|6>)*(M<rsub|7>*M<rsub|8>)))>
      </hidden*>|<\hidden*>
        <item>Truncated power series

        First renormalize <math|f(z)\<mapsto\>f(\<rho\>*z)>.
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Implementing effective real numbers I>

    <strong|<with|color|red|Representation and main methods>><vspace|0.5fn>

    <\code>
      class real_rep {

      protected:

      \ \ double \ \ cost;

      \ \ interval best;

      \;

      public:

      \ \ virtual interval compute () = 0;

      \ \ virtual int precision_for (double cost) = 0;

      \;

      \ \ real_rep (): cost (1.0), best (compute ()) {}

      \ \ interval improve (double new_cost);

      \ \ interval approximate (const dyadic& err);

      };
    </code>
  </hidden>|<\hidden>
    <tit|Implementing effective real numbers II>

    <strong|<with|color|red|Improving the approximation>><vspace|0.5fn>

    <\code>
      interval real_rep::improve (double new_cost) {

      \ \ if (new_cost \<less\>= cost) return best;

      \ \ cost= max (new_cost, 2.0 * cost);

      \ \ set_precision (precision_for (cost));

      \ \ best= compute ();

      \ \ restore_precision ();

      \ \ return best;

      }
    </code>

    <\code>
      interval real_rep::approximate (const dyadic& err) {

      \ \ while (radius (best) \<gtr\>= err)

      \ \ \ \ (void) improve (2 * cost);

      \ \ return best;

      }
    </code>
  </hidden>|<\hidden>
    <tit|Model for complexity analysis>

    <with|color|red|Global approximation problem>

    <unroll|<\shown>
      <with|color|blue|Input>: an acyclic graph <math|G> with for each node
      <math|\<alpha\>\<in\>G>:

      <\itemize>
        <item>A real function <math|f<rsub|\<alpha\>>> from the library.

        Induces by induction a real number
        <math|x<rsub|\<alpha\>>=f<rsub|\<alpha\>>(x<rsub|\<alpha\>[1]>,\<ldots\>,x<rsub|\<alpha\>[\|\<alpha\>\|]>)>.

        <item>A tolerance <math|\<varepsilon\><rsub|\<alpha\>>\<in\>\<bbb-D\><rsup|\<gtr\>>>.
      </itemize>
    </shown>|<\hidden*>
      <with|color|blue|Output>: for each node an interval
      <math|\<b-x\><rsub|\<alpha\>>\<ni\>x<rsub|\<alpha\>>> with

      <\itemize>
        <item><math|r<rsub|\<b-x\><rsub|\<alpha\>>>\<less\>\<varepsilon\><rsub|\<alpha\>>>.

        <item><math|\<b-x\><rsub|\<alpha\>>\<supseteq\>f<rsub|\<alpha\>>(\<b-x\><rsub|\<alpha\>[1]>,\<ldots\>,\<b-x\><rsub|\<alpha\>[\|\<alpha\>\|]>)>.
      </itemize>
    </hidden*>|<\hidden*>
      <with|color|blue|Drawbacks>

      <\itemize>
        <item>Does not model incremental computations.

        <item>No dependency of computations on intermediate results.
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Example>

    <switch|<\shown>
      \;

      <\with|par-mode|center>
        <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.6gw|0.299996gh>>|gr-geometry|<tuple|geometry|0.481472par|0.398042par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|gr-color|red|<graphics|<with|text-at-halign|center|<text-at|sin|<point|-3|3>>>|<with|text-at-halign|center|<text-at|<math|+>|<point|-1|3>>>|<with|text-at-halign|center|<text-at|<math|\<times\>>|<point|0|1>>>|<with|text-at-halign|center|<text-at|2|<point|-1|-1>>>|<with|text-at-halign|center|<text-at|<math|3>|<point|1|-1>>>|<with|text-at-halign|center|<text-at|cos|<point|-3|1>>>|<with|text-at-halign|center|<text-at|1|<point|-3|-1>>>|<line|<point|-3|2.7>|<point|-3|1.5>>|<line|<point|-1.3|2.7>|<point|-2.7|1.5>>|<line|<point|-0.7|2.7>|<point|0|1.5>>|<line|<point|-3|0.7>|<point|-3|-0.5>>|<line|<point|-0.2|0.7>|<point|-0.9|-0.5>>|<line|<point|0.2|0.7>|<point|0.9|-0.5>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.01>>|<point|-3|3.6>>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.1>>|<point|-1|3.6>>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.0001>>|<point|1|-1.5>>>>>

        \;
      </with>
    </shown>|<\hidden>
      \;

      <\with|par-mode|center>
        <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1cm|<tuple|0.599999gw|0.3gh>>|gr-geometry|<tuple|geometry|0.481473par|0.392872par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-text-at-halign|center|gr-color|red|<graphics|<with|text-at-halign|center|<text-at|<math|0.51>|<point|-3|3>>>|<with|text-at-halign|center|<text-at|<math|6.5>|<point|-1|3>>>|<with|text-at-halign|center|<text-at|<math|6.00>|<point|0|1>>>|<with|text-at-halign|center|<text-at|2.00|<point|-1|-1>>>|<with|text-at-halign|center|<text-at|<math|3.0000>|<point|1|-1>>>|<with|text-at-halign|center|<text-at|0<math|.540>|<point|-3|1>>>|<with|text-at-halign|center|<text-at|1.000|<point|-3|-1>>>|<line|<point|-3|2.7>|<point|-3|1.5>>|<line|<point|-1.3|2.7>|<point|-2.7|1.5>>|<line|<point|-0.7|2.7>|<point|0|1.5>>|<line|<point|-3|0.7>|<point|-3|-0.5>>|<line|<point|-0.2|0.7>|<point|-0.9|-0.5>>|<line|<point|0.2|0.7>|<point|0.9|-0.5>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.01>>|<point|-3|3.6>>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.1>>|<point|-1|3.6>>>|<with|text-at-halign|center|<text-at|<with|font-base-size|7|<with|color|red|0.0001>>|<point|1|-1.5>>>>>

        \;
      </with>
    </hidden>>

    \;
  </hidden>|<\hidden>
    <tit|Total versus final computation cost>

    For each node <math|\<alpha\>\<in\>G>, let

    <\itemize>
      <item><math|T<rsub|\<alpha\>,1>,\<ldots\>,T<rsub|\<alpha\>,p<rsub|\<alpha\>>>>:
      requested costs of the successive evaluations of
      <math|x<rsub|\<alpha\>>>.

      <item><math|t<rsub|\<alpha\>,1>,\<ldots\>,t<rsub|\<alpha\>,p<rsub|\<alpha\>>>>:
      actual costs of the successive evaluations of <math|x<rsub|\<alpha\>>>.

      <item><math|t<rsub|\<alpha\>>=t<rsub|\<alpha\>,1>+\<cdots\>+t<rsub|\<alpha\>,p<rsub|\<alpha\>>>>
      and <math|t<rsup|fin><rsub|\<alpha\>>=t<rsub|\<alpha\>,p<rsub|\<alpha\>>>>
    </itemize>

    <switch|<\shown>
      By construction <math|T<rsub|\<alpha\>,1>=1,T<rsub|\<alpha\>,2>=2,T<rsub|\<alpha\>,3>=4,\<ldots\>>.

      However, we do <with|color|red|not> necessarily have
      <math|t<rsub|\<alpha\>,i>=T<rsub|\<alpha\>,i>>, unless <math|\<alpha\>>
      is a leaf.

      Indeed: <math|x=\<um\>y>, where <math|y> admits a slow approximation
      algorithm.
    </shown>|<\hidden>
      Nevertheless: for each <math|\<alpha\>>, we have
      <math|t<rsub|\<alpha\>,1>\<leqslant\>\<cdots\>\<leqslant\>t<rsub|\<alpha\>,p<rsub|\<alpha\>>>>.

      Let<nbsp><math|\<lambda\>> be a node for which
      <math|p=p<rsub|\<lambda\>>> is maximal (necessarily a leaf).

      Setting <math|t=<big|sum><rsub|\<alpha\>>t<rsub|\<alpha\>>> and
      <math|t<rsup|fin>=<big|sum><rsub|\<alpha\>>t<rsup|fin><rsub|\<alpha\>><big|.>>,
      we then have

      <\equation*>
        t=<big|sum><rsub|\<alpha\>,i><big|.>t<rsub|\<alpha\>,i>\<leqslant\><big|sum><rsub|\<alpha\>>p<rsub|\<alpha\>>*t<rsub|\<alpha\>><rsup|fin><big|.>\<leqslant\>p*t<rsup|fin>.
      </equation*>

      It follows that

      <\equation*>
        t<rsup|fin>\<leqslant\>t\<leqslant\>(log<rsub|2>
        t<rsup|fin>)*t<rsup|fin>.
      </equation*>
    </hidden>>
  </hidden>|<\hidden>
    <tit|Final versus optimal computation cost>

    Now consider an optimal solution and let

    <\itemize>
      <item><math|t<rsup|opt><rsub|\<alpha\>>> time spent to compute
      <math|\<b-x\><rsub|\<alpha\>>>.

      <item><math|t<rsup|opt>=<big|sum><rsub|\<alpha\>>t<rsup|opt><rsub|\<alpha\>>>.
    </itemize>

    Denoting by <math|s> the size of <math|G>, it can be shown that

    <\equation*>
      t<rsup|opt>\<leqslant\>t<rsup|fin>\<leqslant\>2*s*t<rsup|opt>.
    </equation*>

    This bound is nevertheless ``optimal'':

    <\equation*>
      y=x<rsub|1>*\<cdots\>*x<rsub|n>,
    </equation*>

    with <math|x<rsub|1>=\<cdots\>=x<rsub|n>=0> and exactly one of the
    <math|x<rsub|i>> has a slow approximation algorithm.
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|page-screen-top|5mm>
    <associate|prog-scripts|maxima>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|tfin-t-bound|<tuple|1|?>>
  </collection>
</references>